freedombone-app-matrix 26KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # matrix server
  12. #
  13. # https://raw.githubusercontent.com/silvio/docker-matrix
  14. #
  15. # License
  16. # =======
  17. #
  18. # Copyright (C) 2016 Bob Mottram <bob@freedombone.net>
  19. #
  20. # This program is free software: you can redistribute it and/or modify
  21. # it under the terms of the GNU Affero General Public License as published by
  22. # the Free Software Foundation, either version 3 of the License, or
  23. # (at your option) any later version.
  24. #
  25. # This program is distributed in the hope that it will be useful,
  26. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  27. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  28. # GNU Affero General Public License for more details.
  29. #
  30. # You should have received a copy of the GNU Affero General Public License
  31. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  32. VARIANTS='full full-vim chat'
  33. IN_DEFAULT_INSTALL=0
  34. SHOW_ON_ABOUT=1
  35. MATRIX_DATA_DIR='/var/lib/matrix'
  36. MATRIX_HTTP_PORT=8558
  37. MATRIX_ID_HTTP_PORT=8557
  38. MATRIX_PORT=8448
  39. MATRIX_ID_PORT=8081
  40. MATRIX_ONION_PORT=8109
  41. MATRIX_ID_ONION_PORT=8111
  42. MATRIX_REPO="https://github.com/matrix-org/synapse"
  43. MATRIX_COMMIT='f5a4001bb116c468cc5e8e0ae04a1c570e2cb171'
  44. SYDENT_REPO="https://github.com/matrix-org/sydent"
  45. SYDENT_COMMIT='99edbd4c80c42b76e26f696054fcbbceecb25d5f'
  46. REPORT_STATS="no"
  47. MATRIX_SECRET=
  48. matrix_variables=(ONION_ONLY
  49. MY_USERNAME
  50. MATRIX_SECRET
  51. DEFAULT_DOMAIN_NAME)
  52. function matrix_nginx {
  53. create_default_web_site
  54. # append the matrix server to the web site config
  55. matrix_nginx_site=/etc/nginx/sites-available/$DEFAULT_DOMAIN_NAME
  56. if ! grep -q "# End of Matrix Server" $matrix_nginx_site; then
  57. if [[ $ONION_ONLY == "no" ]]; then
  58. echo '# Matrix Server' >> $matrix_nginx_site
  59. echo 'server {' >> $matrix_nginx_site
  60. echo " listen ${MATRIX_HTTP_PORT} ssl;" >> $matrix_nginx_site
  61. echo " listen [::]:${MATRIX_HTTP_PORT} ssl;" >> $matrix_nginx_site
  62. echo " server_name ${DEFAULT_DOMAIN_NAME};" >> $matrix_nginx_site
  63. echo '' >> $matrix_nginx_site
  64. echo ' # Security' >> $matrix_nginx_site
  65. function_check nginx_ssl
  66. nginx_ssl ${DEFAULT_DOMAIN_NAME}
  67. function_check nginx_disable_sniffing
  68. nginx_disable_sniffing ${DEFAULT_DOMAIN_NAME}
  69. echo ' add_header Strict-Transport-Security max-age=15768000;' >> $matrix_nginx_site
  70. echo '' >> $matrix_nginx_site
  71. echo ' # Logs' >> $matrix_nginx_site
  72. echo ' access_log /dev/null;' >> $matrix_nginx_site
  73. echo ' error_log /dev/null;' >> $matrix_nginx_site
  74. echo '' >> $matrix_nginx_site
  75. echo ' # Index' >> $matrix_nginx_site
  76. echo ' index index.html;' >> $matrix_nginx_site
  77. echo '' >> $matrix_nginx_site
  78. echo ' # Location' >> $matrix_nginx_site
  79. echo ' location / {' >> $matrix_nginx_site
  80. function_check nginx_limits
  81. nginx_limits ${DEFAULT_DOMAIN_NAME} '15m'
  82. echo " proxy_pass http://localhost:${MATRIX_PORT};" >> $matrix_nginx_site
  83. echo ' proxy_set_header X-Forwarded-For $remote_addr;' >> $matrix_nginx_site
  84. echo ' }' >> $matrix_nginx_site
  85. echo '}' >> $matrix_nginx_site
  86. echo '' >> $matrix_nginx_site
  87. echo 'server {' >> $matrix_nginx_site
  88. echo " listen ${MATRIX_ID_HTTP_PORT} ssl;" >> $matrix_nginx_site
  89. echo " listen [::]:${MATRIX_ID_HTTP_PORT} ssl;" >> $matrix_nginx_site
  90. echo " server_name ${DEFAULT_DOMAIN_NAME};" >> $matrix_nginx_site
  91. echo '' >> $matrix_nginx_site
  92. echo ' # Security' >> $matrix_nginx_site
  93. function_check nginx_ssl
  94. nginx_ssl ${DEFAULT_DOMAIN_NAME}
  95. function_check nginx_disable_sniffing
  96. nginx_disable_sniffing ${DEFAULT_DOMAIN_NAME}
  97. echo ' add_header Strict-Transport-Security max-age=15768000;' >> $matrix_nginx_site
  98. echo '' >> $matrix_nginx_site
  99. echo ' # Logs' >> $matrix_nginx_site
  100. echo ' access_log /dev/null;' >> $matrix_nginx_site
  101. echo ' error_log /dev/null;' >> $matrix_nginx_site
  102. echo '' >> $matrix_nginx_site
  103. echo ' # Index' >> $matrix_nginx_site
  104. echo ' index index.html;' >> $matrix_nginx_site
  105. echo '' >> $matrix_nginx_site
  106. echo ' # Location' >> $matrix_nginx_site
  107. echo ' location / {' >> $matrix_nginx_site
  108. function_check nginx_limits
  109. nginx_limits ${DEFAULT_DOMAIN_NAME} '15m'
  110. echo " proxy_pass http://localhost:${MATRIX_ID_PORT};" >> $matrix_nginx_site
  111. echo ' proxy_set_header X-Forwarded-For $remote_addr;' >> $matrix_nginx_site
  112. echo ' }' >> $matrix_nginx_site
  113. echo '}' >> $matrix_nginx_site
  114. echo '' >> $matrix_nginx_site
  115. else
  116. echo '# Matrix Server' >> $matrix_nginx_site
  117. fi
  118. echo 'server {' >> $matrix_nginx_site
  119. echo " listen 127.0.0.1:$MATRIX_ONION_PORT default_server;" >> $matrix_nginx_site
  120. echo " server_name $DEFAULT_DOMAIN_NAME;" >> $matrix_nginx_site
  121. echo '' >> $matrix_nginx_site
  122. function_check nginx_disable_sniffing
  123. nginx_disable_sniffing $DEFAULT_DOMAIN_NAME
  124. echo '' >> $matrix_nginx_site
  125. echo ' # Logs' >> $matrix_nginx_site
  126. echo ' access_log /dev/null;' >> $matrix_nginx_site
  127. echo ' error_log /dev/null;' >> $matrix_nginx_site
  128. echo '' >> $matrix_nginx_site
  129. echo ' # Location' >> $matrix_nginx_site
  130. echo ' location / {' >> $matrix_nginx_site
  131. function_check nginx_limits
  132. nginx_limits $DEFAULT_DOMAIN_NAME '15m'
  133. echo " proxy_pass http://localhost:${MATRIX_PORT};" >> $matrix_nginx_site
  134. echo ' proxy_set_header X-Forwarded-For $remote_addr;' >> $matrix_nginx_site
  135. echo ' }' >> $matrix_nginx_site
  136. echo '}' >> $matrix_nginx_site
  137. echo '' >> $matrix_nginx_site
  138. echo 'server {' >> $matrix_nginx_site
  139. echo " listen 127.0.0.1:$MATRIX_ID_ONION_PORT default_server;" >> $matrix_nginx_site
  140. echo " server_name $DEFAULT_DOMAIN_NAME;" >> $matrix_nginx_site
  141. echo '' >> $matrix_nginx_site
  142. function_check nginx_disable_sniffing
  143. nginx_disable_sniffing $DEFAULT_DOMAIN_NAME
  144. echo '' >> $matrix_nginx_site
  145. echo ' # Logs' >> $matrix_nginx_site
  146. echo ' access_log /dev/null;' >> $matrix_nginx_site
  147. echo ' error_log /dev/null;' >> $matrix_nginx_site
  148. echo '' >> $matrix_nginx_site
  149. echo ' # Location' >> $matrix_nginx_site
  150. echo ' location / {' >> $matrix_nginx_site
  151. function_check nginx_limits
  152. nginx_limits $DEFAULT_DOMAIN_NAME '15m'
  153. echo " proxy_pass http://localhost:${MATRIX_ID_PORT};" >> $matrix_nginx_site
  154. echo ' proxy_set_header X-Forwarded-For $remote_addr;' >> $matrix_nginx_site
  155. echo ' }' >> $matrix_nginx_site
  156. echo '}' >> $matrix_nginx_site
  157. echo '# End of Matrix Server' >> $matrix_nginx_site
  158. fi
  159. systemctl restart nginx
  160. systemctl restart turn
  161. systemctl restart matrix
  162. systemctl restart sydent
  163. # wait for nginx to start otherwise user add fails later
  164. sleep 5
  165. }
  166. function matrix_generate_homeserver_file {
  167. local filepath="${1}"
  168. cd /etc/matrix
  169. python -m synapse.app.homeserver \
  170. --config-path "${filepath}" \
  171. --generate-config \
  172. --report-stats ${REPORT_STATS} \
  173. --server-name ${DEFAULT_DOMAIN_NAME}
  174. }
  175. function matrix_generate_identityserver_file {
  176. local filepath="${1}"
  177. cd /etc/sydent
  178. python -m sydent.sydent \
  179. --config-path "${filepath}" \
  180. --generate-config \
  181. --report-stats ${REPORT_STATS} \
  182. --server-name ${DEFAULT_DOMAIN_NAME}
  183. }
  184. function matrix_configure_homeserver_yaml {
  185. local turnkey="${1}"
  186. local filepath="${2}"
  187. local ymltemp="$(mktemp)"
  188. awk -v TURNURIES="turn_uris: [\"turn:${DEFAULT_DOMAIN_NAME}:${TURN_HTTP_PORT}?transport=udp\", \"turn:${DEFAULT_DOMAIN_NAME}:${TURN_HTTP_PORT}?transport=tcp\"]" \
  189. -v TURNSHAREDSECRET="turn_shared_secret: \"${turnkey}\"" \
  190. -v PIDFILE="pid_file: ${MATRIX_DATA_DIR}/homeserver.pid" \
  191. -v DATABASE="database: \"${MATRIX_DATA_DIR}/homeserver.db\"" \
  192. -v LOGFILE="log_file: \"/dev/null\"" \
  193. -v MEDIASTORE="media_store_path: \"${MATRIX_DATA_DIR}/media_store\"" \
  194. '{
  195. sub(/turn_shared_secret: "YOUR_SHARED_SECRET"/, TURNSHAREDSECRET);
  196. sub(/turn_uris: \[\]/, TURNURIES);
  197. sub(/pid_file: \/homeserver.pid/, PIDFILE);
  198. sub(/database: "\/homeserver.db"/, DATABASE);
  199. sub(/log_file: "\/homeserver.log"/, LOGFILE);
  200. sub(/media_store_path: "\/media_store"/, MEDIASTORE);
  201. print;
  202. }' "${filepath}" > "${ymltemp}"
  203. mv ${ymltemp} "${filepath}"
  204. sed -i 's|no_tls: .*|no_tls: true|g' "${filepath}"
  205. sed -i 's| tls: .*| tls: false|g' "${filepath}"
  206. sed -i 's|enable_registration_captcha.*|enable_registration_captcha: False|g' "${filepath}"
  207. sed -i "s|database: \".*|database: \"${MATRIX_DATA_DIR}/homeserver.db\"|g" "${filepath}"
  208. sed -i "s|media_store_path:.*|media_store_path: \"${MATRIX_DATA_DIR}/media_store\"|g" "${filepath}"
  209. sed -i "s|pid_file:.*|pid_file: \"${MATRIX_DATA_DIR}/homeserver.pid\"|g" "${filepath}"
  210. sed -i "s|log_file:.*|log_file: \"/dev/null\"|g" "${filepath}"
  211. sed -i 's|bind_address:.*|bind_address: 127.0.0.1|g' "${filepath}"
  212. sed -i '0,/x_forwarded:.*/s//x_forwarded: true/' "${filepath}"
  213. sed -i "s|server_name:.*|server_name: \"${DEFAULT_DOMAIN_NAME}\"|g" "${filepath}"
  214. sed -i "/trusted_third_party_id_servers:/a - ${DEFAULT_DOMAIN_NAME}" "${filepath}"
  215. sed -i "s|- ${DEFAULT_DOMAIN_NAME}| - ${DEFAULT_DOMAIN_NAME}|g" "${filepath}"
  216. sed -i "s|enable_registration:.*|enable_registration: False|g" "${filepath}"
  217. }
  218. function matrix_configure_identityserver {
  219. local filepath=/etc/sydent/sydent.conf
  220. sed -i "s|http.port.*|http.port = $MATRIX_ID_PORT|g" ${filepath}
  221. sed -i "s|db.file.*|db.file = /etc/sydent/sydent.db|g" ${filepath}
  222. sed -i "s|Sydent Validation|Freedombone Matrix Account Validation|g" ${filepath}
  223. sed -i "s|pidfile.path.*|pidfile.path = /etc/sydent/sydent.pid|g" ${filepath}
  224. sed -i "s|log.path.*|log.path = /dev/null|g" ${filepath}
  225. sed -i "s|server.name.*|server.name = ${DEFAULT_DOMAIN_NAME}|g" ${filepath}
  226. }
  227. function matrix_diff {
  228. DIFFPARAMS="${DIFFPARAMS:-Naur}"
  229. DEFAULT_DOMAIN_NAME="${DEFAULT_DOMAIN_NAME:-demo_server_name}"
  230. REPORT_STATS="${REPORT_STATS:-no_or_yes}"
  231. export DEFAULT_DOMAIN_NAME REPORT_STATS
  232. matrix_generate_synapse_file $INSTALL_DIR/homeserver.synapse.yaml
  233. diff -${DIFFPARAMS} $INSTALL_DIR/homeserver.synapse.yaml ${MATRIX_DATA_DIR}/homeserver.yaml
  234. rm $INSTALL_DIR/homeserver.synapse.yaml
  235. }
  236. function matrix_generate {
  237. breakup="0"
  238. [[ -z "${DEFAULT_DOMAIN_NAME}" ]] && echo "STOP! environment variable DEFAULT_DOMAIN_NAME must be set" && breakup="1"
  239. [[ -z "${REPORT_STATS}" ]] && echo "STOP! environment variable REPORT_STATS must be set to 'no' or 'yes'" && breakup="1"
  240. [[ "${breakup}" == "1" ]] && exit 1
  241. [[ "${REPORT_STATS}" != "yes" ]] && [[ "${REPORT_STATS}" != "no" ]] && \
  242. echo "STOP! REPORT_STATS needs to be 'no' or 'yes'" && breakup="1"
  243. homeserver_config=${MATRIX_DATA_DIR}/homeserver.yaml
  244. if [ -f $homeserver_config ]; then
  245. rm $homeserver_config
  246. fi
  247. matrix_generate_homeserver_file $homeserver_config
  248. matrix_configure_homeserver_yaml "${turnkey}" $homeserver_config
  249. }
  250. function remove_user_matrix {
  251. remove_username="$1"
  252. ${PROJECT_NAME}-pass -u $remove_username --rmapp matrix
  253. # TODO: There is no user removal script within synapse
  254. }
  255. function add_user_matrix {
  256. new_username="$1"
  257. new_user_password="$2"
  258. ${PROJECT_NAME}-pass -u $new_username -a matrix -p "$new_user_password"
  259. retval=$(register_new_matrix_user -c ${MATRIX_DATA_DIR}/homeserver.yaml -u "${new_username}" -p "${new_user_password}" -a)
  260. echo "0"
  261. }
  262. function install_interactive_matrix {
  263. APP_INSTALLED=1
  264. }
  265. function change_password_matrix {
  266. curr_username="$1"
  267. new_user_password="$2"
  268. #${PROJECT_NAME}-pass -u "$curr_username" -a matrix -p "$new_user_password"
  269. }
  270. function reconfigure_matrix {
  271. echo -n ''
  272. }
  273. function upgrade_matrix {
  274. systemctl stop turn
  275. systemctl stop matrix
  276. systemctl stop sydent
  277. function_check set_repo_commit
  278. set_repo_commit /etc/matrix "matrix commit" "$MATRIX_COMMIT" $MATRIX_REPO
  279. cd /etc/matrix
  280. pip install --upgrade --process-dependency-links .
  281. set_repo_commit /etc/sydent "sydent commit" "$SYDENT_COMMIT" $SYDENT_REPO
  282. cd /etc/sydent
  283. pip install --upgrade --process-dependency-links .
  284. sed -i 's/ssl.PROTOCOL_SSLv23/ssl.PROTOCOL_TLSv1/g' /usr/local/bin/register_new_matrix_user
  285. chown -R matrix:matrix /etc/matrix
  286. chown -R matrix:matrix /etc/sydent
  287. chown -R matrix:matrix $MATRIX_DATA_DIR
  288. systemctl start turn
  289. systemctl start matrix
  290. systemctl start sydent
  291. }
  292. function backup_local_matrix {
  293. source_directory=/etc/matrix
  294. if [ -d $source_directory ]; then
  295. systemctl stop turn
  296. systemctl stop matrix
  297. systemctl stop sydent
  298. function_check backup_directory_to_usb
  299. backup_directory_to_usb $source_directory matrix
  300. source_directory=$MATRIX_DATA_DIR
  301. if [ -d $source_directory ]; then
  302. backup_directory_to_usb $source_directory matrixdata
  303. fi
  304. source_directory=/etc/sydent
  305. if [ -d $source_directory ]; then
  306. backup_directory_to_usb $source_directory matrixid
  307. fi
  308. systemctl start turn
  309. systemctl start matrix
  310. systemctl start sydent
  311. fi
  312. }
  313. function restore_local_matrix {
  314. if [ -d /etc/matrix ]; then
  315. systemctl stop turn
  316. systemctl stop matrix
  317. systemctl stop sydent
  318. temp_restore_dir=/root/tempmatrix
  319. function_check restore_directory_from_usb
  320. restore_directory_from_usb $temp_restore_dir matrix
  321. cp -r $temp_restore_dir/etc/matrix/* /etc/matrix
  322. if [ ! "$?" = "0" ]; then
  323. function_check backup_unmount_drive
  324. backup_unmount_drive
  325. exit 3783
  326. fi
  327. rm -rf $temp_restore_dir
  328. chown -R matrix:matrix /etc/matrix
  329. temp_restore_dir=/root/tempmatrixdata
  330. restore_directory_from_usb $temp_restore_dir matrixdata
  331. cp -r $temp_restore_dir$MATRIX_DATA_DIR/* $MATRIX_DATA_DIR
  332. if [ ! "$?" = "0" ]; then
  333. function_check backup_unmount_drive
  334. backup_unmount_drive
  335. exit 78352
  336. fi
  337. rm -rf $temp_restore_dir
  338. chown -R matrix:matrix $MATRIX_DATA_DIR
  339. temp_restore_dir=/root/tempmatrixid
  340. restore_directory_from_usb $temp_restore_dir matrixid
  341. cp -r $temp_restore_dir/etc/sydent/* /etc/sydent
  342. if [ ! "$?" = "0" ]; then
  343. function_check backup_unmount_drive
  344. backup_unmount_drive
  345. exit 29562
  346. fi
  347. rm -rf $temp_restore_dir
  348. chown -R matrix:matrix /etc/sydent
  349. systemctl start turn
  350. systemctl start matrix
  351. systemctl start sydent
  352. fi
  353. }
  354. function backup_remote_matrix {
  355. source_directory=/etc/matrix
  356. if [ -d $source_directory ]; then
  357. systemctl stop turn
  358. systemctl stop matrix
  359. systemctl stop sydent
  360. function_check backup_directory_to_friend
  361. backup_directory_to_friend $source_directory matrix
  362. source_directory=$MATRIX_DATA_DIR
  363. if [ -d $source_directory ]; then
  364. backup_directory_to_friend $source_directory matrixdata
  365. fi
  366. source_directory=/etc/sydent
  367. if [ -d $source_directory ]; then
  368. backup_directory_to_friend $source_directory matrixid
  369. fi
  370. systemctl start turn
  371. systemctl start matrix
  372. systemctl start sydent
  373. fi
  374. }
  375. function restore_remote_matrix {
  376. if [ -d /etc/matrix ]; then
  377. systemctl stop turn
  378. systemctl stop matrix
  379. systemctl stop sydent
  380. temp_restore_dir=/root/tempmatrix
  381. function_check restore_directory_from_friend
  382. restore_directory_from_friend $temp_restore_dir matrix
  383. cp -r $temp_restore_dir/etc/matrix/* /etc/matrix
  384. if [ ! "$?" = "0" ]; then
  385. exit 38935
  386. fi
  387. rm -rf $temp_restore_dir
  388. chown -R matrix:matrix /etc/matrix
  389. temp_restore_dir=/root/tempmatrixdata
  390. restore_directory_from_friend $temp_restore_dir matrixdata
  391. cp -r $temp_restore_dir$MATRIX_DATA_DIR/* $MATRIX_DATA_DIR
  392. if [ ! "$?" = "0" ]; then
  393. exit 60923
  394. fi
  395. rm -rf $temp_restore_dir
  396. chown -R matrix:matrix $MATRIX_DATA_DIR
  397. temp_restore_dir=/root/tempmatrixid
  398. restore_directory_from_friend $temp_restore_dir matrixid
  399. cp -r $temp_restore_dir/etc/sydent/* /etc/sydent
  400. if [ ! "$?" = "0" ]; then
  401. exit 738356
  402. fi
  403. rm -rf $temp_restore_dir
  404. chown -R matrix:matrix /etc/sydent
  405. systemctl start turn
  406. systemctl start matrix
  407. systemctl start sydent
  408. fi
  409. }
  410. function remove_matrix {
  411. firewall_remove ${MATRIX_HTTP_PORT}
  412. systemctl stop matrix
  413. systemctl stop sydent
  414. function_check remove_turn
  415. remove_turn
  416. systemctl disable matrix
  417. systemctl disable sydent
  418. if [ -f /etc/systemd/system/matrix.service ]; then
  419. rm /etc/systemd/system/matrix.service
  420. fi
  421. if [ -f /etc/systemd/system/sydent.service ]; then
  422. rm /etc/systemd/system/sydent.service
  423. fi
  424. apt-get -y remove --purge coturn
  425. cd /etc/matrix
  426. pip uninstall .
  427. cd /etc/sydent
  428. pip uninstall .
  429. rm -rf $MATRIX_DATA_DIR
  430. rm -rf /etc/matrix
  431. rm -rf /etc/sydent
  432. deluser matrix
  433. delgroup matrix
  434. remove_onion_service matrix ${MATRIX_ONION_PORT}
  435. remove_onion_service matrix ${MATRIX_ID_ONION_PORT}
  436. sed -i "/# Matrix Server/,/# End of Matrix Server/d" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  437. systemctl restart nginx
  438. remove_completion_param install_matrix
  439. sed -i '/matrix/d' $COMPLETION_FILE
  440. }
  441. function install_identity_server {
  442. if [ ! -d /etc/sydent ]; then
  443. function_check git_clone
  444. git_clone $SYDENT_REPO /etc/sydent
  445. if [ ! -d /etc/sydent ]; then
  446. echo $'Unable to clone sydent repo'
  447. exit 936525
  448. fi
  449. fi
  450. cd /etc/sydent
  451. git checkout $SYDENT_COMMIT -b $SYDENT_COMMIT
  452. set_completion_param "sydent commit" "$SYDENT_COMMIT"
  453. if [ ! -d $INSTALL_DIR/sydent ]; then
  454. mkdir -p $INSTALL_DIR/sydent
  455. fi
  456. pip install --upgrade --process-dependency-links . -b $INSTALL_DIR/sydent
  457. if [ ! "$?" = "0" ]; then
  458. echo $'Failed to install matrix identity server'
  459. exit 798362
  460. fi
  461. function_check matrix_generate_identityserver_file
  462. matrix_generate_identityserver_file /etc/sydent/sydent.conf
  463. if [ ! -f /etc/sydent/sydent.conf ]; then
  464. echo $'Matrix identity server configuration not generated'
  465. exit 72528
  466. fi
  467. function_check matrix_configure_identityserver
  468. matrix_configure_identityserver
  469. if [ ! -f /etc/sydent/sydent.conf ]; then
  470. echo $'Matrix identity server config was not generated'
  471. exit 82352
  472. fi
  473. chmod -R 700 /etc/sydent/sydent.conf
  474. chown -R matrix:matrix /etc/sydent
  475. echo '[Unit]' > /etc/systemd/system/sydent.service
  476. echo 'Description=Sydent Matrix identity server' >> /etc/systemd/system/sydent.service
  477. echo 'After=network.target nginx.target' >> /etc/systemd/system/sydent.service
  478. echo '' >> /etc/systemd/system/sydent.service
  479. echo '[Service]' >> /etc/systemd/system/sydent.service
  480. echo 'Type=simple' >> /etc/systemd/system/sydent.service
  481. echo 'User=matrix' >> /etc/systemd/system/sydent.service
  482. echo "WorkingDirectory=/etc/sydent" >> /etc/systemd/system/sydent.service
  483. echo "ExecStart=/usr/bin/python -m sydent.sydent --config-path /etc/sydent/sydent.conf" >> /etc/systemd/system/sydent.service
  484. echo 'Restart=always' >> /etc/systemd/system/sydent.service
  485. echo 'RestartSec=10' >> /etc/systemd/system/sydent.service
  486. echo '' >> /etc/systemd/system/sydent.service
  487. echo '[Install]' >> /etc/systemd/system/sydent.service
  488. echo 'WantedBy=multi-user.target' >> /etc/systemd/system/sydent.service
  489. systemctl enable sydent
  490. systemctl daemon-reload
  491. systemctl start sydent
  492. if [ ! -f /etc/sydent/sydent.db ]; then
  493. echo $'No matrix identity server database was created'
  494. exit 7354383
  495. fi
  496. chmod -R 700 /etc/sydent/sydent.db
  497. }
  498. function install_home_server {
  499. if [ ! -d /etc/matrix ]; then
  500. function_check git_clone
  501. git_clone $MATRIX_REPO /etc/matrix
  502. if [ ! -d /etc/matrix ]; then
  503. echo $'Unable to clone matrix repo'
  504. exit 6724683
  505. fi
  506. fi
  507. cd /etc/matrix
  508. git checkout $MATRIX_COMMIT -b $MATRIX_COMMIT
  509. set_completion_param "matrix commit" "$MATRIX_COMMIT"
  510. if [ ! -d $INSTALL_DIR/matrix ]; then
  511. mkdir -p $INSTALL_DIR/matrix
  512. fi
  513. pip install --upgrade --process-dependency-links . -b $INSTALL_DIR/matrix
  514. if [ ! "$?" = "0" ]; then
  515. echo $'Failed to install matrix home server'
  516. exit 782542
  517. fi
  518. if [ ! -d $MATRIX_DATA_DIR ]; then
  519. mkdir $MATRIX_DATA_DIR
  520. fi
  521. groupadd matrix
  522. useradd -c "Matrix system account" -d $MATRIX_DATA_DIR -m -r -g matrix matrix
  523. function_check install_turn
  524. install_turn
  525. MATRIX_SECRET="${turnkey}"
  526. function_check matrix_generate
  527. matrix_generate
  528. if [[ -z ${MATRIX_DATA_DIR}/homeserver.yaml ]]; then
  529. echo $'homeserver.yaml is zero size'
  530. exit 783724
  531. fi
  532. chmod -R 700 $MATRIX_DATA_DIR/homeserver.yaml
  533. chown -R matrix:matrix /etc/matrix
  534. chown -R matrix:matrix $MATRIX_DATA_DIR
  535. sed -i 's/ssl.PROTOCOL_SSLv23/ssl.PROTOCOL_TLSv1/g' /usr/local/bin/register_new_matrix_user
  536. echo '[Unit]' > /etc/systemd/system/matrix.service
  537. echo 'Description=Synapse Matrix homeserver' >> /etc/systemd/system/matrix.service
  538. echo 'After=network.target nginx.target' >> /etc/systemd/system/matrix.service
  539. echo '' >> /etc/systemd/system/matrix.service
  540. echo '[Service]' >> /etc/systemd/system/matrix.service
  541. echo 'Type=simple' >> /etc/systemd/system/matrix.service
  542. echo 'User=matrix' >> /etc/systemd/system/matrix.service
  543. echo "WorkingDirectory=/etc/matrix" >> /etc/systemd/system/matrix.service
  544. echo "ExecStart=/usr/bin/python -m synapse.app.homeserver --config-path ${MATRIX_DATA_DIR}/homeserver.yaml" >> /etc/systemd/system/matrix.service
  545. echo 'Restart=always' >> /etc/systemd/system/matrix.service
  546. echo 'RestartSec=10' >> /etc/systemd/system/matrix.service
  547. echo '' >> /etc/systemd/system/matrix.service
  548. echo '[Install]' >> /etc/systemd/system/matrix.service
  549. echo 'WantedBy=multi-user.target' >> /etc/systemd/system/matrix.service
  550. systemctl enable matrix
  551. systemctl daemon-reload
  552. systemctl start matrix
  553. if [ ! -f $MATRIX_DATA_DIR/homeserver.db ]; then
  554. echo $'No matrix home server database was created'
  555. fi
  556. chmod -R 700 $MATRIX_DATA_DIR/homeserver.db
  557. MATRIX_ONION_HOSTNAME=$(add_onion_service matrix ${MATRIX_PORT} ${MATRIX_ONION_PORT})
  558. MATRIX_ID_ONION_HOSTNAME=$(add_onion_service matrixid ${MATRIX_ID_PORT} ${MATRIX_ID_ONION_PORT})
  559. if [ ! ${MATRIX_PASSWORD} ]; then
  560. if [ -f ${IMAGE_PASSWORD_FILE} ]; then
  561. MATRIX_PASSWORD="$(printf `cat $IMAGE_PASSWORD_FILE`)"
  562. else
  563. MATRIX_PASSWORD="$(create_password ${MINIMUM_PASSWORD_LENGTH})"
  564. fi
  565. fi
  566. firewall_add matrix ${MATRIX_HTTP_PORT}
  567. rm -rf ${MATRIX_DATA_DIR}/Maildir
  568. rm -rf ${MATRIX_DATA_DIR}/.mutt
  569. rm -f ${MATRIX_DATA_DIR}/.muttrc
  570. rm -f ${MATRIX_DATA_DIR}/.mutt-alias
  571. rm -f ${MATRIX_DATA_DIR}/.procmailrc
  572. rm -f ${MATRIX_DATA_DIR}/.emacs-mutt
  573. }
  574. function install_matrix {
  575. if [ ! -d $INSTALL_DIR ]; then
  576. mkdir -p $INSTALL_DIR
  577. fi
  578. if [[ ${ONION_ONLY} == 'no' ]]; then
  579. if [ ! -f /etc/ssl/certs/${DEFAULT_DOMAIN_NAME}.pem ]; then
  580. echo $'Obtaining certificate for the main domain'
  581. create_site_certificate ${DEFAULT_DOMAIN_NAME} 'yes'
  582. fi
  583. fi
  584. export DEBIAN_FRONTEND=noninteractive
  585. apt-get -yq install coreutils \
  586. curl file gcc git libevent-2.0-5 \
  587. libevent-dev libffi-dev libffi6 \
  588. libgnutls28-dev libjpeg62-turbo \
  589. libjpeg62-turbo-dev libldap-2.4-2 \
  590. libldap2-dev libsasl2-dev \
  591. libsqlite3-dev libssl-dev \
  592. libssl1.0.0 libtool libxml2 \
  593. libxml2-dev libxslt1-dev libxslt1.1 \
  594. make python python-dev \
  595. python-pip python-psycopg2 \
  596. python-virtualenv sqlite unzip \
  597. zlib1g zlib1g-dev
  598. pip install --upgrade pip
  599. pip install --upgrade python-ldap
  600. pip install --upgrade lxml
  601. function_check install_home_server
  602. install_home_server
  603. function_check install_identity_server
  604. install_identity_server
  605. function_check update_default_domain
  606. update_default_domain
  607. pip install --upgrade --force "pynacl==0.3.0"
  608. function_check matrix_nginx
  609. matrix_nginx
  610. if [[ $(add_user_matrix "${MY_USERNAME}" "${MATRIX_PASSWORD}" | tail -n 1) != "0" ]]; then
  611. echo $'Failed to add matrix admin user';
  612. exit 879352
  613. fi
  614. APP_INSTALLED=1
  615. }